-- Fast video presets for 5d3

-- Script enables video presets in MOVIE Tab ver.1.04

--console will be all over if not applied
  console.hide()
  menu.select("Movie")
  menu.close()
  
-- this script is for 5D3 only
if camera.model_short ~= "5D3" then
   display.notify_box("Script is not working on this cam", 2000)
   return
end

-- preset function begin

-- Preset 3k 2.35:1 24fps TNT-ISO100

function main1()
  console.hide()
  menu.close()
  lv.start()
  lv.zoom = 1

	-- enable sound
	 -- menu.set("Sound recording", "Enable sound", "ON")
	-- if menu.get("Sound recording", "Enable sound", "") ~= "ON" then
	  -- display.notify_box("\nPlease, enable: \n\nmlv_lite.mo \nmlv_snd.mo \ncrop_rec.mo \n\n      ... and run script again", 6000)
	  -- return
	-- end  

	-- warnings 
	while camera.mode ~= MODE.MOVIE do
	  display.notify_box("\nSwitch to MOVIE mode")
	  msleep(1000)
	end

	-- Presets
		
		-- menu.set("Presets", "bitdepth", "10 bit")
		--menu.set("Presets", "set 25fps", "OFF") -- Change to "OFF" to use 24fps by default
		--menu.set("Presets", "reg_8xx8", "-31") -- Set iso-tuning regs
		menu.set("Expo", "ISO", "100")
		menu.set("Presets", "CMOS[0]", 0x113) -- Set iso-tuning regs
		menu.set("Presets", "CMOS[4]", "0") -- Set iso-tuning regs
		menu.set("Presets", "gain_888x", "0") -- Set iso-tuning regs
		menu.set("Presets", "preamp_89ab", "-61") -- Set iso-tuning regs
		menu.set("Presets", "gain_0xfe", "-3") -- Set iso-tuning regs
	  msleep(300)

	-- enable crop_rec.mo. Checking first after trying to enable 3k preset
	if menu.get("Movie", "Presets", "") ~= "3K 1:1" then
	  display.notify_box("\nYou forgot to enable crop_rec.mo", 5000)
	  return
	end
	
	-- movie
	  menu.set("Movie", "FPS override", "OFF")
	  --menu.set("Movie", "HDR video", "OFF")
	  menu.set("RAW video", "Resolution", "3072x1308")
	  menu.set("RAW video", "Aspect ratio", "2.35:1")
	  menu.set("RAW video", "Crop rec preview", "auto mode")
	  menu.set("RAW video", "Data format", "14-bit lossless") 
	  menu.set("RAW video", "Aspect ratio", "2.35:1") 
	  menu.set("RAW video", "Preview", "Framing")
	  menu.select("Movie", "RAW video")
	  msleep(100)
	  menu.open()
	  msleep(100)
	  key.press(KEY.Q)
	  msleep(100)
	  key.press(KEY.SET)
	  msleep(100)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)

	-- Overlay
	  menu.set("Overlay", "Focus Peak", "OFF")
	  menu.set("Overlay", "Zebras", "OFF")
	  menu.set("Overlay", "Magic Zoom", "OFF")
	  menu.set("Overlay", "Cropmarks", "OFF")
	  menu.set("Overlay", "Spotmeter", "OFF")
	  menu.set("Overlay", "False color", "OFF")
	  menu.set("Overlay", "Histogram", "RAW RGB, Log")
	  menu.set("Overlay", "Waveform", "OFF")
	  menu.set("Overlay", "Vectorscope", "OFF")
	  menu.set("Display", "Clear overlays", "OFF")

	-- done, turn on global draw
	  menu.set("Overlay", "Global Draw", "LiveView")

	-- go back to Presets Tab
	  menu.select("Movie", "Fast video presets")
	  msleep(200)
	  menu.open()
	  msleep(200)
	  menu.close()
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)

	-- success!
	display.notify_box("\nScript is done")
end

-- preset function end

--

-- preset function begin

-- Preset 3k 2.35:1 24fps TNT-ISO200

function main2()
  console.hide()
  menu.close()
  lv.start()
  lv.zoom = 1

	-- enable sound
	 -- menu.set("Sound recording", "Enable sound", "ON")
	-- if menu.get("Sound recording", "Enable sound", "") ~= "ON" then
	  -- display.notify_box("\nPlease, enable: \n\nmlv_lite.mo \nmlv_snd.mo \ncrop_rec.mo \n\n      ... and run script again", 6000)
	  -- return
	-- end  

	-- warnings 
	while camera.mode ~= MODE.MOVIE do
	  display.notify_box("\nSwitch to MOVIE mode")
	  msleep(1000)
	end

	-- Presets
		
		-- menu.set("Presets", "bitdepth", "10 bit")
		--menu.set("Presets", "set 25fps", "OFF") -- Change to "OFF" to use 24fps by default
		--menu.set("Presets", "reg_8xx8", "-31") -- Set iso-tuning regs
		menu.set("Expo", "ISO", "200")
		menu.set("Presets", "CMOS[0]", 0x223) -- Set iso-tuning regs
		menu.set("Presets", "CMOS[4]", "0") -- Set iso-tuning regs
		menu.set("Presets", "gain_888x", "0") -- Set iso-tuning regs
		menu.set("Presets", "preamp_89ab", "-49") -- Set iso-tuning regs
		menu.set("Presets", "gain_0xfe", "-4") -- Set iso-tuning regs
	  msleep(300)

	-- enable crop_rec.mo. Checking first after trying to enable 3k preset
	if menu.get("Movie", "Presets", "") ~= "3K 1:1" then
	   display.notify_box("\nYou forgot to enable crop_rec.mo", 5000)
	   return
	end 

	-- movie
	  menu.set("Movie", "FPS override", "OFF")
	  --menu.set("Movie", "HDR video", "OFF")
	  menu.set("RAW video", "Resolution", "3072x1308")
	  menu.set("RAW video", "Aspect ratio", "2.35:1")
	  menu.set("RAW video", "Crop rec preview", "auto mode")
	  menu.set("RAW video", "Data format", "14-bit lossless") 
	  menu.set("RAW video", "Aspect ratio", "2.35:1") 
	  menu.set("RAW video", "Preview", "Framing")
	  menu.select("Movie", "RAW video")
	  msleep(100)
	  menu.open()
	  msleep(100)
	  key.press(KEY.Q)
	  msleep(100)
	  key.press(KEY.SET)
	  msleep(100)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)

	-- Overlay
	  menu.set("Overlay", "Focus Peak", "OFF")
	  menu.set("Overlay", "Zebras", "OFF")
	  menu.set("Overlay", "Magic Zoom", "OFF")
	  menu.set("Overlay", "Cropmarks", "OFF")
	  menu.set("Overlay", "Spotmeter", "OFF")
	  menu.set("Overlay", "False color", "OFF")
	  menu.set("Overlay", "Histogram", "RAW RGB, Log")
	  menu.set("Overlay", "Waveform", "OFF")
	  menu.set("Overlay", "Vectorscope", "OFF")
	  menu.set("Display", "Clear overlays", "OFF")

	-- done, turn on global draw
	  menu.set("Overlay", "Global Draw", "LiveView")

	-- go back to Presets Tab
	  menu.select("Movie", "Fast video presets")
	  msleep(200)
	  menu.open()
	  msleep(200)
	  menu.close()
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)

	-- success!
	display.notify_box("\nScript is done")
end

-- preset function end

-- preset function begin

-- Preset 3k 2.35:1 24fps TNT-ISO400

function main3()
  console.hide()
  menu.close()
  lv.start()
  lv.zoom = 1

	-- enable sound
	 -- menu.set("Sound recording", "Enable sound", "ON")
	-- if menu.get("Sound recording", "Enable sound", "") ~= "ON" then
	  -- display.notify_box("\nPlease, enable: \n\nmlv_lite.mo \nmlv_snd.mo \ncrop_rec.mo \n\n      ... and run script again", 6000)
	  -- return
	-- end  

	-- warnings 
	while camera.mode ~= MODE.MOVIE do
	  display.notify_box("\nSwitch to MOVIE mode")
	  msleep(1000)
	end

	-- Presets
		
		-- menu.set("Presets", "bitdepth", "10 bit")
		--menu.set("Presets", "set 25fps", "OFF") -- Change to "OFF" to use 24fps by default
		--menu.set("Presets", "reg_8xx8", "-31") -- Set iso-tuning regs
		menu.set("Expo", "ISO", "400")
		menu.set("Presets", "CMOS[0]", 0x333) -- Set iso-tuning regs
		menu.set("Presets", "CMOS[4]", "0") -- Set iso-tuning regs
		menu.set("Presets", "gain_888x", "0") -- Set iso-tuning regs
		menu.set("Presets", "preamp_89ab", "-49") -- Set iso-tuning regs
		menu.set("Presets", "gain_0xfe", "-4") -- Set iso-tuning regs
	  msleep(300)

	-- enable crop_rec.mo. Checking first after trying to enable 3k preset
	if menu.get("Movie", "Presets", "") ~= "3K 1:1" then
	 display.notify_box("\nYou forgot to enable crop_rec.mo", 5000)
	 return
	end

	-- movie
	  menu.set("Movie", "FPS override", "OFF")
	  --menu.set("Movie", "HDR video", "OFF")
	  menu.set("RAW video", "Resolution", "3072x1308")
	  menu.set("RAW video", "Aspect ratio", "2.35:1")
	  menu.set("RAW video", "Crop rec preview", "auto mode")
	  menu.set("RAW video", "Data format", "14-bit lossless") 
	  menu.set("RAW video", "Aspect ratio", "2.35:1") 
	  menu.set("RAW video", "Preview", "Framing")
	  menu.select("Movie", "RAW video")
	  msleep(100)
	  menu.open()
	  msleep(100)
	  key.press(KEY.Q)
	  msleep(100)
	  key.press(KEY.SET)
	  msleep(100)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)

	-- Overlay
	  menu.set("Overlay", "Focus Peak", "OFF")
	  menu.set("Overlay", "Zebras", "OFF")
	  menu.set("Overlay", "Magic Zoom", "OFF")
	  menu.set("Overlay", "Cropmarks", "OFF")
	  menu.set("Overlay", "Spotmeter", "OFF")
	  menu.set("Overlay", "False color", "OFF")
	  menu.set("Overlay", "Histogram", "RAW RGB, Log")
	  menu.set("Overlay", "Waveform", "OFF")
	  menu.set("Overlay", "Vectorscope", "OFF")
	  menu.set("Display", "Clear overlays", "OFF")

	-- done, turn on global draw
	  menu.set("Overlay", "Global Draw", "LiveView")

	-- go back to Presets Tab
	  menu.select("Movie", "Fast video presets")
	  msleep(200)
	  menu.open()
	  msleep(200)
	  menu.close()
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)

	-- success!
	display.notify_box("\nScript is done")
end

-- preset function end


-- Preset 3k 2.35:1 24fps ISO800

function main4()
  console.hide()
  menu.close()
  lv.start()
  lv.zoom = 1

	-- enable sound
	 -- menu.set("Sound recording", "Enable sound", "ON")
	-- if menu.get("Sound recording", "Enable sound", "") ~= "ON" then
	  -- display.notify_box("\nPlease, enable: \n\nmlv_lite.mo \nmlv_snd.mo \ncrop_rec.mo \n\n      ... and run script again", 6000)
	  -- return
	-- end  

	-- warnings 
	--while camera.mode ~= MODE.MOVIE do
	  --display.notify_box("\nSwitch to MOVIE mode")
	  --msleep(1000)
	--end

	-- Presets
		
		-- menu.set("Presets", "bitdepth", "10 bit")
		--menu.set("Presets", "set 25fps", "OFF") -- Change to "OFF" to use 24fps by default
		menu.set("Expo", "ISO", "800")
		menu.set("Presets", "CMOS[0]", 0x443) -- Set iso-tuning regs
		menu.set("Presets", "CMOS[4]", "0") -- Set iso-tuning regs
		menu.set("Presets", "gain_888x", "0") -- Set iso-tuning regs
		menu.set("Presets", "preamp_89ab", "-49") -- Set iso-tuning regs
		menu.set("Presets", "gain_0xfe", "-4") -- Set iso-tuning regs
	  msleep(300)

	-- enable crop_rec.mo. Checking first after trying to enable 3k preset
	if menu.get("Movie", "Presets", "") ~= "3K 1:1" then
	  display.notify_box("\nYou forgot to enable crop_rec.mo", 5000)
	  return
	end

	-- movie
	  menu.set("Movie", "FPS override", "OFF")
	  --menu.set("Movie", "HDR video", "OFF")
	  menu.set("RAW video", "Resolution", "3072x1308")
	  menu.set("RAW video", "Aspect ratio", "2.35:1")
	  menu.set("RAW video", "Crop rec preview", "auto mode")
	  menu.set("RAW video", "Data format", "14-bit lossless") 
	  menu.set("RAW video", "Aspect ratio", "2.35:1") 
	  menu.set("RAW video", "Preview", "Framing")
	  menu.select("Movie", "RAW video")
	  msleep(100)
	  menu.open()
	  msleep(100)
	  key.press(KEY.Q)
	  msleep(100)
	  key.press(KEY.SET)
	  msleep(100)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)

	-- Overlay
	  menu.set("Overlay", "Focus Peak", "OFF")
	  menu.set("Overlay", "Zebras", "OFF")
	  menu.set("Overlay", "Magic Zoom", "OFF")
	  menu.set("Overlay", "Cropmarks", "OFF")
	  menu.set("Overlay", "Spotmeter", "OFF")
	  menu.set("Overlay", "False color", "OFF")
	  menu.set("Overlay", "Histogram", "RAW RGB, Log")
	  menu.set("Overlay", "Waveform", "OFF")
	  menu.set("Overlay", "Vectorscope", "OFF")
	  menu.set("Display", "Clear overlays", "OFF")

	-- done, turn on global draw
	  menu.set("Overlay", "Global Draw", "LiveView")

	-- go back to Presets Tab
	  menu.select("Movie", "Fast video presets")
	  msleep(200)
	  menu.open()
	  msleep(200)
	  menu.close()
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)

	-- success!
	display.notify_box("\nScript is done")
end

-- preset function end

-- Preset 3k 2.35:1 24fps ISO1600

function main5()
  console.hide()
  menu.close()
  lv.start()
  lv.zoom = 1

	-- enable sound
	 -- menu.set("Sound recording", "Enable sound", "ON")
	-- if menu.get("Sound recording", "Enable sound", "") ~= "ON" then
	  -- display.notify_box("\nPlease, enable: \n\nmlv_lite.mo \nmlv_snd.mo \ncrop_rec.mo \n\n      ... and run script again", 6000)
	  -- return
	-- end  

	-- warnings 
	while camera.mode ~= MODE.MOVIE do
	  display.notify_box("\nSwitch to MOVIE mode")
	  msleep(1000)
	end

	--Expo
	  menu.set("Expo", "ISO", "1600")

	-- Presets
		
		-- menu.set("Presets", "bitdepth", "10 bit")
		--menu.set("Presets", "set 25fps", "OFF") -- Change to "OFF" to use 24fps by default
		menu.set("Expo", "ISO", "1600")
		menu.set("Presets", "CMOS[0]", 0x553) -- Set iso-tuning regs
		menu.set("Presets", "CMOS[4]", "0") -- Set iso-tuning regs
		menu.set("Presets", "gain_888x", "0") -- Set iso-tuning regs
		menu.set("Presets", "preamp_89ab", "-50") -- Set iso-tuning regs
		menu.set("Presets", "gain_0xfe", "-4") -- Set iso-tuning regs
	  msleep(300)

	-- enable crop_rec.mo. Checking first after trying to enable 3k preset
	if menu.get("Movie", "Presets", "") ~= "3K 1:1" then
	  display.notify_box("\nYou forgot to enable crop_rec.mo", 5000)
	  return
	end

	-- movie
	  menu.set("Movie", "FPS override", "OFF")
	  --menu.set("Movie", "HDR video", "OFF")
	  menu.set("RAW video", "Resolution", "3072x1308")
	  menu.set("RAW video", "Aspect ratio", "2.35:1")
	  menu.set("RAW video", "Crop rec preview", "auto mode")
	  menu.set("RAW video", "Data format", "14-bit lossless") 
	  menu.set("RAW video", "Aspect ratio", "2.35:1") 
	  menu.set("RAW video", "Preview", "Framing")
	  menu.select("Movie", "RAW video")
	  msleep(100)
	  menu.open()
	  msleep(100)
	  key.press(KEY.Q)
	  msleep(100)
	  key.press(KEY.SET)
	  msleep(100)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)
	  key.press(KEY.WHEEL_DOWN)

	-- Overlay
	  menu.set("Overlay", "Focus Peak", "OFF")
	  menu.set("Overlay", "Zebras", "OFF")
	  menu.set("Overlay", "Magic Zoom", "OFF")
	  menu.set("Overlay", "Cropmarks", "OFF")
	  menu.set("Overlay", "Spotmeter", "OFF")
	  menu.set("Overlay", "False color", "OFF")
	  menu.set("Overlay", "Histogram", "RAW RGB, Log")
	  menu.set("Overlay", "Waveform", "OFF")
	  menu.set("Overlay", "Vectorscope", "OFF")
	  menu.set("Display", "Clear overlays", "OFF")

	-- done, turn on global draw
	  menu.set("Overlay", "Global Draw", "LiveView")

	-- go back to Presets Tab
	  menu.select("Movie", "Fast video presets")
	  msleep(200)
	  menu.open()
	  msleep(200)
	  menu.close()
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)
	  key.press(KEY.MENU)
	  msleep(600)

	-- success!
	display.notify_box("\nScript is done")
end

-- preset function end


mymenu = menu.new
{
    parent = "Movie",
    name = "Fast video presets",
    help = "Choose a preset with predefined settings",
    submenu =
    {
		{
        name = "TNT-ISO100 3K 3072p 24fps 2:35.1",
	    select = function(this) task.create(main1) end,
	    help = "3K preset / 24fps / Ratio: 2.35:1 / 14-bit lossless / iso100",
		--help2 = "For 24fps set 25fps to OFF in Presets menu Q",
        },
		{
        name = "TNT-ISO200 3K 3072p 24fps 2:35.1",
	    select = function(this) task.create(main2) end,
	    help = "3K preset / 24fps / Ratio: 2.35:1 / 14-bit lossless / iso200",
		--help2 = "For 24fps set 25fps to OFF in Presets menu Q",
        },
		{
         name = "TNT-ISO400 3K 3072p 24fps 2:35.1",
	    select = function(this) task.create(main3) end,
	    help = "3K preset / 24fps / Ratio: 2.35:1 / 14-bit lossless / iso400",
		--help2 = "For 24fps set 25fps to OFF in Presets menu Q",
        },
        {
        name = "TNT-ISO800 3K 3072p 24fps 2:35.1",
	    select = function(this) task.create(main4) end,
	    help = "3K preset / 24fps / Ratio: 2.35:1 / 14-bit lossless / iso800",
		--help2 = "For 24fps set 25fps to OFF in Presets menu Q",
        },
        {
        name = "TNT-ISO1600 3K 3072p 24fps 2:35.1",
	    select = function(this) task.create(main5) end,
	    help = "3K preset / 24fps / Ratio: 2.35:1 / 14-bit lossless / iso800",
		--help2 = "For 24fps set 25fps to OFF in Presets menu Q",
        },
        
    },
}